tests: Use here-doc kadmin in Java test
[heimdal.git] / tests / plugin / check-pac.in
blob595d70e1ca2977deee0ecbd11f33bcc191e3492c
1 #!/bin/sh
3 # Copyright (c) 2006 - 2007 Kungliga Tekniska Högskolan
4 # (Royal Institute of Technology, Stockholm, Sweden).
5 # All rights reserved.
7 # Redistribution and use in source and binary forms, with or without
8 # modification, are permitted provided that the following conditions
9 # are met:
11 # 1. Redistributions of source code must retain the above copyright
12 # notice, this list of conditions and the following disclaimer.
14 # 2. Redistributions in binary form must reproduce the above copyright
15 # notice, this list of conditions and the following disclaimer in the
16 # documentation and/or other materials provided with the distribution.
18 # 3. Neither the name of the Institute nor the names of its contributors
19 # may be used to endorse or promote products derived from this software
20 # without specific prior written permission.
22 # THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
23 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
24 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
25 # ARE DISCLAIMED. IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
26 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
27 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
28 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
29 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
30 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
31 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
32 # SUCH DAMAGE.
34 # $Id$
37 srcdir="@srcdir@"
38 env_setup="@env_setup@"
39 objdir="@objdir@"
40 EGREP="@EGREP@"
42 . ${env_setup}
44 testfailed="echo test failed; cat messages.log; exit 1"
46 # If there is no useful db support compiled in, disable test
47 ../db/have-db || exit 77
49 R=TEST.H5L.SE
50 R2=TEST2.H5L.SE
52 port=@port@
54 kadmin="${TESTS_ENVIRONMENT} ../../kadmin/kadmin -l -r ${R}"
55 kdc="${TESTS_ENVIRONMENT} ../../kdc/kdc --addresses=localhost -P $port"
57 server=host/datan.test.h5l.se
58 cache="FILE:${objdir}/cache.krb5"
59 keytabfile=${objdir}/server.keytab
60 keytab="FILE:${keytabfile}"
61 rodc_kvno="3058761729"
63 kinit="${TESTS_ENVIRONMENT} ../../kuser/kinit -c $cache ${afs_no_afslog}"
64 klist="${TESTS_ENVIRONMENT} ../../kuser/klist -c $cache"
65 kgetcred="${TESTS_ENVIRONMENT} ../../kuser/kgetcred -c $cache"
66 kdestroy="${TESTS_ENVIRONMENT} ../../kuser/kdestroy -c $cache ${afs_no_unlog}"
67 test_apreq="${TESTS_ENVIRONMENT} ../../lib/krb5/test_ap-req"
69 KRB5_CONFIG="${objdir}/krb5.conf"
70 export KRB5_CONFIG
72 rm -f ${keytabfile}
73 rm -f current-db*
74 rm -f out-*
75 rm -f mkey.file*
77 > messages.log
79 echo Creating database
80 ${kadmin} \
81 init \
82 --realm-max-ticket-life=1day \
83 --realm-max-renewable-life=1month \
84 ${R} || exit 1
86 ${kadmin} add -p foo --use-defaults foo@${R} || exit 1
87 ${kadmin} add -p bar --use-defaults ${server}@${R} || exit 1
88 ${kadmin} modify --kvno=$rodc_kvno "krbtgt/${R}@${R}" || exit 1
89 ${kadmin} ext -k ${keytab} ${server}@${R} || exit 1
91 ${kadmin} \
92 init \
93 --realm-max-ticket-life=1day \
94 --realm-max-renewable-life=1month \
95 ${R2} || exit 1
97 ${kadmin} add -p foo --use-defaults foo@${R2} || exit 1
98 ${kadmin} add -p bar --use-defaults bar@${R2} || exit 1
99 ${kadmin} ext -k ${keytab} bar@${R2} || exit 1
101 echo "Doing database check"
102 ${kadmin} check ${R} || exit 1
103 ${kadmin} check ${R2} || exit 1
105 echo foo > ${objdir}/foopassword
107 echo "Empty log"
108 > messages.log
110 echo Starting kdc
111 ${kdc} --detach --testing || { echo "kdc failed to start"; cat messages.log; exit 1; }
112 kdcpid=`getpid kdc`
114 cleanup() {
115 echo signal killing kdc
116 kill -9 ${kdcpid}
117 trap '' EXIT INT TERM
118 cat messages.log
119 exit 1
121 trap cleanup EXIT INT TERM
123 ec=0
125 echo "Check that KDC plugin module was loaded "
126 grep "kdc plugin init" messages.log >/dev/null || \
127 { ec=1 ; eval "${testfailed}"; }
129 echo "Getting client initial tickets"; > messages.log
130 ${kinit} --password-file=${objdir}/foopassword foo@${R} || \
131 { ec=1 ; eval "${testfailed}"; }
132 echo "Getting tickets" ; > messages.log
133 ${kgetcred} ${server}@${R} || { ec=1 ; eval "${testfailed}"; }
134 echo "Verify PAC on server"; > messages.log
135 ${test_apreq} --verify-pac ${server}@${R} ${keytab} ${cache} || \
136 { ec=1 ; eval "${testfailed}"; }
137 ${kdestroy}
139 echo "Getting client initial tickets (pac)"; > messages.log
140 ${kinit} --request-pac --password-file=${objdir}/foopassword foo@${R} || \
141 { ec=1 ; eval "${testfailed}"; }
142 echo "Getting tickets" ; > messages.log
143 ${kgetcred} ${server}@${R} || { ec=1 ; eval "${testfailed}"; }
144 echo "Verify PAC on server (pac)"; > messages.log
145 ${test_apreq} --verify-pac ${server}@${R} ${keytab} ${cache} || \
146 { ec=1 ; eval "${testfailed}"; }
147 ${kdestroy}
149 echo "Getting client initial tickets (no pac)"; > messages.log
150 ${kinit} --no-request-pac --password-file=${objdir}/foopassword foo@${R} || \
151 { ec=1 ; eval "${testfailed}"; }
152 echo "Getting tickets" ; > messages.log
153 ${kgetcred} ${server}@${R} || { ec=1 ; eval "${testfailed}"; }
154 echo "Verify PAC on server (no pac)"; > messages.log
155 ${test_apreq} --verify-pac ${server}@${R} ${keytab} ${cache} 2> /dev/null && \
156 { ec=1 ; eval "${testfailed}"; }
157 ${test_apreq} ${server}@${R} ${keytab} ${cache} 2> /dev/null && \
158 { ec=1 ; eval "${testfailed}"; }
159 echo "Check the --no-verify-pac option"; > messages.log
160 ${test_apreq} --no-verify-pac ${server}@${R} ${keytab} ${cache} 2> /dev/null || \
161 { ec=1 ; eval "${testfailed}"; }
162 ${kdestroy}
164 echo "Getting client initial tickets (no pac - realm config)"; > messages.log
165 ${kinit} --no-request-pac --password-file=${objdir}/foopassword foo@${R2} || \
166 { ec=1 ; eval "${testfailed}"; }
167 echo "Getting tickets" ; > messages.log
168 ${kgetcred} bar@${R2} || { ec=1 ; eval "${testfailed}"; }
169 echo "Verify PAC on server (no pac - realm config)"; > messages.log
170 ${test_apreq} --verify-pac bar@${R2} ${keytab} ${cache} 2> /dev/null && \
171 { ec=1 ; eval "${testfailed}"; }
172 ${test_apreq} bar@${R2} ${keytab} ${cache} 2> /dev/null && \
173 { ec=1 ; eval "${testfailed}"; }
176 echo "killing kdc (${kdcpid})"
177 kill $kdcpid || exit 1
179 trap "" EXIT
181 exit $ec